"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const stripe_1 = __importDefault(require("stripe"));
class Commission {
    constructor(token, amount, comission, customer_id, partner_account_id, card_id) {
        this.token = token;
        this.amount = amount;
        this.comission = comission;
        this.customer_id = customer_id;
        this.partner_account_id = partner_account_id;
        this.card_id = card_id;
        this.currency = 'USD';
    }
    changeCurrency(currency) {
        this.currency = currency;
    }
    createCharge() {
        return __awaiter(this, void 0, void 0, function* () {
            const stripe = new stripe_1.default(this.token, { typescript: true, apiVersion: '2020-08-27' });
            const admin_amount = (this.amount * this.comission) / 100;
            const partner_amount = Math.round((this.amount - admin_amount) * 100);
            yield stripe.charges.create({
                amount: Math.round(this.amount * 100),
                currency: this.currency,
                customer: this.customer_id,
                source: this.card_id,
                capture: true,
                transfer_data: {
                    amount: partner_amount,
                    destination: this.partner_account_id
                }
            }).then(value => {
                console.log(value);
                return value;
            }).catch(error => {
                throw new Error("Somee error occured while processing payment");
            });
        });
    }
}
exports.default = Commission;
//# sourceMappingURL=index.js.map