import Stripe from 'stripe';

class Commission {
    public currency;
    protected stripe;
    constructor(private token: string, public amount: number, public comission: number, private customer_id : string, private partner_account_id : string, private card_id: string ) { 
        this.currency = 'usd';
        this.stripe = new Stripe(this.token, { typescript: true, apiVersion: '2020-08-27' });
    }


    get stripeInstance() {
        if(this.stripe){
            return this.stripe;
        }
    }

    changeCurrency(currency: string) {
        this.currency = currency.toLowerCase();
    }


    async createCharge(){
       

        const admin_amount = (this.amount * this.comission) / 100;
        const partner_amount = Math.round((this.amount - admin_amount) * 100);
        
       await this.stripe.charges.create({
            amount: Math.round(this.amount * 100),
            currency: this.currency,
            customer: this.customer_id,
            source: this.card_id,
            capture: true,
            transfer_data:{
                amount: partner_amount,
                destination: this.partner_account_id
            }
        }).then(value=>{
            console.log(value);
            return value
        }).catch(error=>{
            throw new Error("Somee error occured while processing payment");
        })
    }

}

export default Commission;